/*
 * Module of obtaining temperatures
 * from the sensors DS18B20
 * part of meteorological station
 */

int get_temp(int nn)
{
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  int Temp;

  if ( !ds.search(addr)) {
    Serial.println("No more addresses.");
    ds.reset_search();
    return 0;
  }
/*
  if (OneWire::crc8(my_addr[nn - 1], 7) != addr[7]) {
    Serial.println("CRC is not valid!");
    return 1;
  }
*/
 
  ds.reset();
  ds.select(my_addr[nn - 1]);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end
  delay(1000);              // maybe 750ms is enough, maybe not

  present = ds.reset();
  ds.select(my_addr[nn - 1]);
  ds.write(0xBE);          // Read Scratchpad
  for ( i = 0; i < 9; i++) {         // we need 9 bytes
    data[i] = ds.read();
  }
  Temp = (data[1] << 8) + data[0]; //take the two bytes from the response relating to temperature
  delay (1000);
  return Temp;

  /*
   ************** from an example to library **************************
   */
   /*
 int16_t raw = (data[1] << 8) | data[0];
    if (type_s) {
      raw = raw << 3; // 9 bit resolution default
      if (data[7] == 0x10) {
        raw = (raw & 0xFFF0) + 12 - data[6];
      }
    } else {
      byte cfg = (data[4] & 0x60);
      if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
      else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
      else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    }
//    celsius = (float)raw / 16.0;
//   Serial.print(nn); Serial.write(' '); Serial.println(raw);
//    Serial.print(nn); Serial.write(' '); Serial.println(celsium);
  return raw;
*/
}

