/* The project a meteorological station for the smart house
 * Version 0.1.1
 *
 * 2015, Aleksandr Gorokhov
 * License: Free, without any warranties
 */

//#include <SD.h>
#include <SPI.h>
#include <Ethernet.h>
#include <OneWire.h>
#include <Wire.h>
#include <BMP085.h>
#include "DHT.h"
#include "RTClib.h"

BMP085 dps = BMP085();
long Temperature085 = 0, Pressure085 = 0, Altitude085 = 0;
float celsius;
float h;
float t;
RTC_Millis RTC;
DateTime dt;
String pr_date;
String pr_time;

#define DHTTYPE DHT11   // DHT 11 
DHT dht(8, DHTTYPE);

OneWire  ds(7);  // on pin 7

/*
 ******************  Installation Ethernet  ************************
 */
byte mac[] = { 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xFF };
byte ip[] = { 192, 168, 1, 111 };
byte gateway[] = { 192, 168, 1, 1 };
byte subnet[] = { 255, 255, 255, 0 };
EthernetServer server(10001);
/*
 *****************  Installation Addres DS18B20  *******************
 */
byte my_addr[3][8] = {{0x28, 0xFF, 0xE6, 0x2E, 0x64, 0x14, 2, 0x3B},
                      {0x28, 0xFF, 0xB6, 0x4A, 0x64, 0x14, 1, 0xD2},
                      {0x28, 0xFF, 0x95, 0x14, 0x64, 0x14, 1, 0xA9},
                     };
/*
 *************************  Void Setup  ****************************
 */
void setup() {
  Serial.begin(9600);
  Serial.println("start");

  // start the Ethernet connection and the server:
  // инициализация Ethernet shield
  Ethernet.begin(mac, ip, gateway, subnet);
  // запуск сервера
  server.begin();

  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());

  RTC.begin(DateTime(__DATE__, __TIME__));
  
  Wire.begin();
  delay(500);
  dps.init();
  //dps.init(MODE_ULTRA_HIGHRES, 69400, true);

}
/*
 ***************************  Void Loop  *****************************
 */
void loop ()
{
  EthernetClient client = server.available();
  if (client) {
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();
          client.print("Web-server Arduino-UNO-328 <br>Ethernet/SD-Shield V 2.0 <br>House meteorological station<br>Version 0.1.1<br><br> IP: ");

          for (byte thisByte = 0; thisByte < 4; thisByte++) {
            client.print(Ethernet.localIP()[thisByte], DEC);
            client.print(".");
          }
          client.print("<br><br>");
          client.print(get_date());
          client.print(" ");
          client.print(get_time());
          client.print("<br><br>");

          // DS18B20

          client.print("temperatura DS18B20: <br>");
          int j;
          int n = 4; // кол-во датчиков DS18B20
          for (j = 1; j < n; j++)
          {
            int Temp = get_temp(j);
            client.print("temp "); client.print(j);
            client.print(" = "); client.print((float)Temp / 16);
            client.print(" C*");
            client.print("<br>");
          }

          // DH11

          if (isnan(t) || isnan(h)) {
            client.print("<br>Failed to read from DHT<br>");
          } else {
            client.print("<br>DH11: <br>");
            h = dht.readHumidity();
            t = dht.readTemperature();
            client.print("temp "); client.print(j); client.print(" = ");
            client.print(t); client.print(" C*");
            client.print("<br>");
            client.print("humidity "); client.print(j); client.print(" = ");
            client.print(h);
            client.print(" %<br>");
            j++;
          }

          // bmp085

          client.print("<br>BM085: <br>");
          dps.getTemperature(&Temperature085);
          dps.getPressure(&Pressure085);
          dps.getAltitude(&Altitude085);
          client.print("temp "); client.print(j); client.print(" = ");
          client.print(Temperature085 * 0.1); client.print(" C*");
          client.print("<br>");
          client.print("pressure "); client.print(j); client.print(" = ");
          client.print(Pressure085 / 133.3);
          client.println("<br>");
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
  }
}

